package util
{
	import mx.controls.advancedDataGridClasses.AdvancedDataGridColumn;
	import mx.core.*;
	import mx.formatters.DateFormatter;
	import mx.formatters.NumberFormatter;
	import mx.utils.ObjectUtil;

	public class AdvancedDataGridColumnEx extends AdvancedDataGridColumn
	{

		public function AdvancedDataGridColumnEx(columnName:String=null)
		{
			super(columnName);			
		}
		

		// Tipo de Filtro
		private var _filterType:String;
		public function get filterType():String
		{					
			return _filterType;
		}
		
		public function set filterType(value:String):void
		{

			switch(value)
			{
				case "text":
					
					this.headerRenderer = new ClassFactory(AdvancedDataGridHeaderFilterRenderer);
					break;
				case "combo":
					
					this.headerRenderer = new ClassFactory(AdvancedDataGridHeaderComboFilterRenderer);
					break;
				default:
					this.headerRenderer = null
					break;
			}				

			_filterType = value;
		}

		/*
		*DataTypes:
		*datetime
		*string
		*int
		*double
		*/
		private var _dataType:String;
		public function get dataType():String
		{					
			return _dataType;
		}
		
		public function set dataType(value:String):void
		{

			var df:DateFormatter = new DateFormatter();
			var nf:NumberFormatter = new NumberFormatter();
			
			switch(value)
			{
				case "datetime":
					//var df:DateFormatter = new DateFormatter();
					//df.formatString = "YYYY-MM-DD H:NN";
					df.formatString = "DD-MM-YYYY H:NN";
					this.formatter = df;
					this.sortCompareFunction = compareSortDate;						
					break;
				case "month/year":
					//var df:DateFormatter = new DateFormatter();
					df.formatString = "MMM-YYYY";
					this.formatter = df;				
					this.sortCompareFunction = compareSortDate;						
					break;
				case "hour":
					//var df:DateFormatter = new DateFormatter();
					df.formatString = "H:NN";
					this.formatter = df;					
					this.sortCompareFunction = compareSortDate;						
					break;
				case "int":
					nf.precision = "0";
					//nf.thousandsSeparatorTo = "."
					nf.useThousandsSeparator = "true";
					this.formatter = nf;
					this.sortCompareFunction = compareSortNumber;						
					break;
				//case "image":
					//var lolo = this.itemRenderer.newInstance();
					
					
				default:
					this.sortCompareFunction = null;
					break;
			}
			_dataType = value;
		}
		
		public function compareSortDate(itemA:Object, itemB:Object):int
		{
			var dateA:Date = new Date(Date.parse(itemA[this.dataField]));
 	 		var dateB:Date = new Date(Date.parse(itemB[this.dataField]));
    		return ObjectUtil.dateCompare(dateA, dateB);
		}						

		public function compareSortNumber(itemA:Object, itemB:Object):int
		{
			return ObjectUtil.numericCompare(itemA[this.dataField],itemB[this.dataField]);
		}						

		public function compareSortX(itemA:Object, itemB:Object):int
		{
			
			var curDataField:String;
			curDataField = this.dataField;
			
			switch(this._dataType)
			{
				case "datetime":	
//					var dateA:Date = new Date(Date.parse(itemA[itemA]));
//         	 		var dateB:Date = new Date(Date.parse(itemB[itemB]));
					var dateA:Date = new Date(Date.parse(itemA[curDataField]));
           	 		var dateB:Date = new Date(Date.parse(itemB[curDataField]));
            		return ObjectUtil.dateCompare(dateA, dateB);
            		break;
            	case "int":
            		return ObjectUtil.numericCompare(itemA[curDataField],itemB[curDataField]);	
            		break;
            	default:
            		return 0;
            		break;
			}			
		}						

	}
}