using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;
using SACI.Comum.DataSet;

namespace SACI.AcessoDados
{
    public class cIC : cBaseAcessoDados
    {

        public void Listar(dsIC ds, int id, int tipoPesquisa)
        {
            selectCommand = new SqlCommand();

            if (id != 0)
                selectCommand.Parameters.Add(new SqlParameter("@ID_IC", id));

            if (tipoPesquisa != 0)
                selectCommand.Parameters.Add(new SqlParameter("@TipoPesquisa", tipoPesquisa));

            base.DoSelect(ds, "p_ListarIC", ds.IC.TableName);
        }

        public int Salvar(dsIC.ICRow ic)
        {
            dsIC.ICRow icAnterior = RetornaValorAnterior(ic.ID_IC);

            selectCommand = new SqlCommand();
            //
            selectCommand.Parameters.Add(new SqlParameter("@ID_IC", ic.ID_IC));
            selectCommand.Parameters.Add(new SqlParameter("@Descricao", ic.Descricao));
            selectCommand.Parameters.Add(new SqlParameter("@IP", ic.IP));
            selectCommand.Parameters.Add(new SqlParameter("@Status", ic.Status));
            selectCommand.Parameters.Add(new SqlParameter("@Monitorar", "0"));
            selectCommand.Parameters.Add(new SqlParameter("@ID_TipoIC", ic.ID_TipoIC));
            selectCommand.Parameters.Add(new SqlParameter("@ID_Departamento", ic.ID_Departamento));
            selectCommand.Parameters.Add(new SqlParameter("@ID_ICPai", ic.ID_ICPai));
            //
            dsIC ds = new dsIC();
            base.DoSelect(ds, "p_SalvarIC", "SalvarIC");

            base.GeraTrilhaAuditoria(ic.ID_IC, icAnterior, ic);

            //
            return int.Parse(ds.SalvarIC[0].Retorno.ToString());
        }


        private dsIC.ICRow RetornaValorAnterior(int ID_IC)
        {

            dsIC ds = new dsIC();

            dsIC.ICRow icAnterior;

            if (ID_IC == 0)
            {
                // Se  um registro novo, retorna uma linha em branco
                icAnterior = ds.IC.NewICRow();
            }
            else
            {
                // se existe um ID, pesquisa no banco de dados
                Listar(ds, ID_IC, 0);
                icAnterior = ds.IC[0];
            }

            return icAnterior;

        }

        public void Excluir(dsIC.ICRow IC)
        {

            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@ID", IC.ID_IC));

            dsFilial ds = new dsFilial();
            base.DoSelect(ds, "p_ExcluirIC", "ExcluirIC");

        }

        public void ListarICAtributo(dsIC ds, int id_IC, int id_TipoIC, int id_ICAtributo)
        {
            selectCommand = new SqlCommand();

            if (id_IC != 0)
                selectCommand.Parameters.Add(new SqlParameter("@ID_IC", id_IC));

            if (id_ICAtributo != 0)
                selectCommand.Parameters.Add(new SqlParameter("@ID_ICAtributo", id_ICAtributo));

            if (id_TipoIC != 0)
                selectCommand.Parameters.Add(new SqlParameter("@ID_TipoIC", id_TipoIC));

            base.DoSelect(ds, "p_ListarICAtributo", ds.ICAtributo.TableName);
        }

        public void ListarTipoICAtributoItem(dsIC ds, int id_TipoIC)
        {
            selectCommand = new SqlCommand();

            if (id_TipoIC != 0)
                selectCommand.Parameters.Add(new SqlParameter("@ID_TipoIC", id_TipoIC));

            base.DoSelect(ds, "p_ListarTipoICAtributoItem", ds.TipoICAtributoItem.TableName);
        }

        public int SalvarICAtributo(dsIC.ICAtributoRow icAtributo)
        {
            //dsIC.ICAtributoRow icAtributoAnterior = RetornaValorAnteriorICAtributo(icAtributo.ID_ICAtributo);

            selectCommand = new SqlCommand();

            selectCommand.Parameters.Add(new SqlParameter("@ID_ICAtributo", icAtributo.ID_ICAtributo));
            selectCommand.Parameters.Add(new SqlParameter("@Valor", icAtributo.Valor));
            selectCommand.Parameters.Add(new SqlParameter("@ID_IC", icAtributo.ID_IC));
            selectCommand.Parameters.Add(new SqlParameter("@ID_TipoICAtributo", icAtributo.ID_TipoICAtributo));

//#if DEBUG
//            System.Diagnostics.Trace.WriteLine("=======================================================");
//            System.Diagnostics.Trace.WriteLine("@ID_ICAtributo: " + icAtributo.ID_ICAtributo);
//            System.Diagnostics.Trace.WriteLine("@Valor: " + icAtributo.Valor);
//            System.Diagnostics.Trace.WriteLine("@ID_IC: " + icAtributo.ID_IC);
//            System.Diagnostics.Trace.WriteLine("@ID_TipoICAtributo: " + icAtributo.ID_TipoICAtributo);
//#endif

            dsIC ds = new dsIC();
            base.DoSelect(ds, "p_SalvarICAtributo", "SalvarICAtributo");

            //base.GeraTrilhaAuditoria(icAtributo.ID_IC, icAtributoAnterior, icAtributo);

            //
            return int.Parse(ds.SalvarICAtributo[0].Retorno.ToString());
        }

        public void SalvarValorMonitoradoICAtributo(int id_ICAtributo, String valor)
        {


            selectCommand = new SqlCommand();

            selectCommand.Parameters.Add(new SqlParameter("@ID_ICAtributo", id_ICAtributo));
            selectCommand.Parameters.Add(new SqlParameter("@Valor", valor));

            dsIC ds = new dsIC();
            base.DoSelect(ds, "p_SalvarValorMonitoradoICAtributo", "SalvarICAtributo");

            //return int.Parse(ds.SalvarICAtributo[0].Retorno.ToString());
        }



        private dsIC.ICAtributoRow RetornaValorAnteriorICAtributo(int ID_ICAtributo)
        {

            dsIC ds = new dsIC();

            dsIC.ICAtributoRow icAtributoAnterior;

            if (ID_ICAtributo == 0)
            {
                // Se  um registro novo, retorna uma linha em branco
                icAtributoAnterior = ds.ICAtributo.NewICAtributoRow();
            }
            else
            {
                // se existe um ID, pesquisa no banco de dados
                ListarICAtributo(ds, 0, 0, ID_ICAtributo);
                icAtributoAnterior = ds.ICAtributo[0];
            }

            return icAtributoAnterior;

        }

        public void ListarICAtributoHistorico(dsIC ds, int id_ICAtributo)
        {
            selectCommand = new SqlCommand();

            if (id_ICAtributo != 0)
                selectCommand.Parameters.Add(new SqlParameter("@ID_ICAtributo", id_ICAtributo));
            
            //GerarLogFileSystem("=======================================================");
            //GerarLogFileSystem("@ID_ICAtributo: " + id_ICAtributo);

            try
            {
                base.DoSelect(ds, "p_ListarICAtributoHistorico", ds.ICAtributoHistorico.TableName);
            }
            catch (Exception ex)
            {
                GerarLogFileSystem("\n--------------------------------------------");
                GerarLogFileSystem("ERRO\n--------------------------------------------");
                GerarLogFileSystem("Mensagem: " + ex.Message);
                GerarLogFileSystem("Data: " + ex.Data);
                GerarLogFileSystem("--------------------------------------------");                
            }
        }

    }
}
