using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;
using SACI.Comum.DataSet; 

namespace SACI.AcessoDados
{
    public class cIC_antigo : cBaseAcessoDados 
    {

        public void Listar(dsIC ds, int id)
        {
            selectCommand = new SqlCommand();

            if (id != 0)
                selectCommand.Parameters.Add(new SqlParameter("@id", id));

            base.DoSelect(ds, "p_ListarIC", ds.IC.TableName);
        }

        public void Listar(dsIC ds, string clausulaWhere)
        {
            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@ClausulaWhere", clausulaWhere));
            base.DoSelect(ds, "p_ListarIC", ds.IC.TableName);
        }

        public void ListarICAtributo(dsIC ds, int ID_ICAtributo, int ID_IC, int ID_TipoICAtributo)
        {
            selectCommand = new SqlCommand();

            if (ID_ICAtributo != 0)
                selectCommand.Parameters.Add(new SqlParameter("@ID_ICAtributo", ID_ICAtributo));

            if (ID_IC != 0 && ID_TipoICAtributo != 0)
            {
                selectCommand.Parameters.Add(new SqlParameter("@ID_IC", ID_IC));
                selectCommand.Parameters.Add(new SqlParameter("@ID_TipoICAtributo", ID_TipoICAtributo));
            }

            base.DoSelect(ds, "p_ListarICAtributo", ds.ICAtributo.TableName);
        }

        public int SalvarIC(dsIC.ICRow ic)
        {

            dsIC.ICRow icAnterior = RetornaValorAnteriorIC(ic.ID_IC);

            selectCommand = new SqlCommand();
            //
            selectCommand.Parameters.Add(new SqlParameter("@ID", ic.ID_IC));
            selectCommand.Parameters.Add(new SqlParameter("@Descricao", ic.Descricao));
            selectCommand.Parameters.Add(new SqlParameter("@Status", ic.Status));
            selectCommand.Parameters.Add(new SqlParameter("@Monitorar", ic.Monitorar));
            selectCommand.Parameters.Add(new SqlParameter("@ID_TipoIC", ic.ID_TipoIC));
            selectCommand.Parameters.Add(new SqlParameter("@ID_Departamento", ic.ID_Departamento));
            //
            dsIC ds = new dsIC();
            base.DoSelect(ds, "p_SalvarIC", "SalvarIC");

            //base.GeraTrilhaAuditoria(ic.ID_IC, icAnterior, ic);

            //
            return int.Parse(ds.SalvarIC[0].Retorno.ToString());
        }


        private dsIC.ICRow RetornaValorAnteriorIC(int ID_IC)
        {

            dsIC ds = new dsIC();

            dsIC.ICRow icAnterior;

            if (ID_IC == 0)
            {
                // Se  um registro novo, retorna uma linha em branco
                icAnterior = ds.IC.NewICRow();
            }
            else
            {
                // se existe um ID, pesquisa no banco de dados
                Listar(ds, ID_IC);
                //                dsEmpresa.EmpresaRow empresaAnterior = ds.Empresa[0];
                icAnterior = ds.IC[0];
            }

            return icAnterior;

        }

        public int SalvarICAtributo(dsIC.ICAtributoRow icAtributo)
        {

            dsIC.ICAtributoRow icAtributoAnterior = RetornaValorAnteriorICAtributo(icAtributo.ID_ICAtributo);

            selectCommand = new SqlCommand();
            //
            selectCommand.Parameters.Add(new SqlParameter("@ID", icAtributo.ID_ICAtributo));
            selectCommand.Parameters.Add(new SqlParameter("@Valor", icAtributo.Valor));
            selectCommand.Parameters.Add(new SqlParameter("@ID_IC", icAtributo.ID_IC));
            selectCommand.Parameters.Add(new SqlParameter("@ID_TipoICAtributo", icAtributo.ID_TipoICAtributo));
            //
            dsIC ds = new dsIC();
            base.DoSelect(ds, "p_SalvarICAtributo", "SalvarICAtributo");

            //base.GeraTrilhaAuditoria(icAtributo.ID_ICAtributo, icAtributoAnterior, icAtributo);

            //
            return int.Parse(ds.SalvarICAtributo[0].Retorno.ToString());
        }


        private dsIC.ICAtributoRow RetornaValorAnteriorICAtributo(int ID_ICAtributo)
        {

            dsIC ds = new dsIC();

            dsIC.ICAtributoRow icAtributoAnterior;

            if (ID_ICAtributo == 0)
            {
                // Se  um registro novo, retorna uma linha em branco
                icAtributoAnterior = ds.ICAtributo.NewICAtributoRow();
            }
            else
            {
                // se existe um ID, pesquisa no banco de dados
                ListarICAtributo (ds, ID_ICAtributo, 0, 0);
                //                dsEmpresa.EmpresaRow empresaAnterior = ds.Empresa[0];
                icAtributoAnterior = ds.ICAtributo[0];
            }

            return icAtributoAnterior;

        }
    }
}
