using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;
using SACI.Comum.DataSet;

namespace SACI.AcessoDados
{
    public class cMonitoramento : cBaseAcessoDados
    {

        // Lista todos os Monitoramentos de um atributo 
        public void ListarConfiguracaoMonitoramento(dsMonitoramento ds, int id_ICAtributo)
        {
            selectCommand = new SqlCommand();
            if (id_ICAtributo != 0)
                selectCommand.Parameters.Add(new SqlParameter("@ID_ICAtributo", id_ICAtributo));

            base.DoSelect(ds, "p_ListarConfiguracaoMonitoramento", ds.ConfiguracaoMonitoramento.TableName);
        }

        public void ListarDadosAMonitorar(dsMonitoramento ds, String coletor)
        {

            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@coletor", coletor));

            base.DoSelect(ds, "p_ListarDadosAMonitorar", ds.DadosAMonitorar.TableName);
        }

        //lista um Monitoramento especfico, atravs de seu ID
        public void ListarConfiguracaoMonitoramentoEspecifico(dsMonitoramento ds, int id_ConfiguracaoMonitoramento)
        {
            selectCommand = new SqlCommand();
            //
            //if (id_ConfiguracaoMonitoramento != 0)
                selectCommand.Parameters.Add(new SqlParameter("@ID_ConfiguracaoMonitoramento", id_ConfiguracaoMonitoramento));

            //
            base.DoSelect(ds, "p_ListarConfiguracaoMonitoramentoEspecifico", ds.ConfiguracaoMonitoramento.TableName);
        }

        public void ListarOID(dsMonitoramento ds, int id_OID)
        {
            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@ID_OID", id_OID));

            base.DoSelect(ds, "p_ListarOID", ds.OID.TableName);
        }


        public int SalvarConfiguracaoMonitoramento(dsMonitoramento.ConfiguracaoMonitoramentoRow configuracaoMonitoramentoRow)
        {
            dsMonitoramento.ConfiguracaoMonitoramentoRow configuracaoMonitoramentoAnteriorRow = RetornaValorAnteriorConfiguracaoMonitoramento(configuracaoMonitoramentoRow.ID_ConfiguracaoMonitoramento);

            selectCommand = new SqlCommand();

            selectCommand.Parameters.Add(new SqlParameter("@ID_ConfiguracaoMonitoramento", configuracaoMonitoramentoRow.ID_ConfiguracaoMonitoramento));
            selectCommand.Parameters.Add(new SqlParameter("@ID_ICAtributo", configuracaoMonitoramentoRow.ID_ICAtributo));
            selectCommand.Parameters.Add(new SqlParameter("@ID_OID", configuracaoMonitoramentoRow.ID_OID));
            selectCommand.Parameters.Add(new SqlParameter("@Descricao", configuracaoMonitoramentoRow.Descricao));
            selectCommand.Parameters.Add(new SqlParameter("@SequenciaOID", configuracaoMonitoramentoRow.SequenciaOID));
            selectCommand.Parameters.Add(new SqlParameter("@TipoRetorno", configuracaoMonitoramentoRow.TipoRetorno));
            selectCommand.Parameters.Add(new SqlParameter("@IntervaloVerificacao", configuracaoMonitoramentoRow.IntervaloVerificacao));
            selectCommand.Parameters.Add(new SqlParameter("@ColetorResponsavel", configuracaoMonitoramentoRow.ColetorResponsavel));
            selectCommand.Parameters.Add(new SqlParameter("@Ativo", configuracaoMonitoramentoRow.Ativo));
             
            dsMonitoramento ds = new dsMonitoramento();
            base.DoSelect(ds, "p_SalvarConfiguracaoMonitoramento", "SalvarConfiguracaoMonitoramento");

            base.GeraTrilhaAuditoria(configuracaoMonitoramentoRow.ID_ConfiguracaoMonitoramento, configuracaoMonitoramentoAnteriorRow, configuracaoMonitoramentoRow);

            return int.Parse(ds.SalvarConfiguracaoMonitoramento[0].Retorno.ToString());
        }



        private dsMonitoramento.ConfiguracaoMonitoramentoRow RetornaValorAnteriorConfiguracaoMonitoramento(int ID_ConfiguracaoMonitoramento)
        {

            dsMonitoramento ds = new dsMonitoramento();

            dsMonitoramento.ConfiguracaoMonitoramentoRow configuracaoMonitoramentoAnteriorRow;

            if (ID_ConfiguracaoMonitoramento == 0)
            {
                // Se  um registro novo, retorna uma linha em branco
                configuracaoMonitoramentoAnteriorRow = ds.ConfiguracaoMonitoramento.NewConfiguracaoMonitoramentoRow();
            }
            else
            {
                // se existe um ID, pesquisa no banco de dados
                ListarConfiguracaoMonitoramentoEspecifico(ds, ID_ConfiguracaoMonitoramento);
                configuracaoMonitoramentoAnteriorRow = ds.ConfiguracaoMonitoramento[0];
            }

            return configuracaoMonitoramentoAnteriorRow;

        }

        public void AtualizarDataProximoMonitoramento(int id_ConfiguracaoMonitoramento)
        {

            selectCommand = new SqlCommand();

            selectCommand.Parameters.Add(new SqlParameter("@ID_ConfiguracaoMonitoramento", id_ConfiguracaoMonitoramento));

            dsMonitoramento ds = new dsMonitoramento();
            base.DoSelect(ds, "p_AtualizarDataProximoMonitoramento", "SalvarConfiguracaoMonitoramento");

            //return int.Parse(ds.SalvarConfiguracaoMonitoramento[0].Retorno.ToString());
        }


        public void ExcluirConfiguracaoMonitoramento(dsMonitoramento.ConfiguracaoMonitoramentoRow configuracaoMonitoramentoRow)
        {

            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@ID_ConfiguracaoMonitoramento", configuracaoMonitoramentoRow.ID_ConfiguracaoMonitoramento));

            dsFilial ds = new dsFilial();
            base.DoSelect(ds, "p_ExcluirConfiguracaoMonitoramento", "ExcluirConfiguracaoMonitoramento");

        }

    }
}

