using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;
using SACI.Comum.DataSet;

namespace SACI.AcessoDados
{
    public class cNodo : cBaseAcessoDados
    {

        public void Listar(dsNodo ds, int id)
        {
            selectCommand = new SqlCommand();
            //
            if (id != 0)
                selectCommand.Parameters.Add(new SqlParameter("@ID_Nodo", id));

            //
            base.DoSelect(ds, "p_ListarNodo", ds.Nodo.TableName);
        }

        public void Listar(dsNodo ds, string clausulaWhere)
        {
            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@ClausulaWhere", clausulaWhere));
            base.DoSelect(ds, "p_ListarNodo", ds.Nodo.TableName);
        }

        public int Salvar(dsNodo.NodoRow Nodo)
        {

            dsNodo.NodoRow NodoAnterior = RetornaValorAnterior(Nodo.ID_Nodo);
  
            selectCommand = new SqlCommand();
            //
            selectCommand.Parameters.Add(new SqlParameter("@ID", Nodo.ID_Nodo));
            selectCommand.Parameters.Add(new SqlParameter("@Descricao", Nodo.Descricao));
            selectCommand.Parameters.Add(new SqlParameter("@IP", Nodo.IP));
            selectCommand.Parameters.Add(new SqlParameter("@Localizacao", Nodo.Localizacao));
            selectCommand.Parameters.Add(new SqlParameter("@Status", Nodo.Status));
            selectCommand.Parameters.Add(new SqlParameter("@ID_IC", Nodo.ID_IC));
            //

            dsNodo ds = new dsNodo();
            base.DoSelect(ds, "p_SalvarNodo", "SalvarNodo");

            base.GeraTrilhaAuditoria(Nodo.ID_Nodo, NodoAnterior, Nodo);  

            return int.Parse(ds.SalvarNodo[0].Retorno.ToString());
        }

        private dsNodo.NodoRow RetornaValorAnterior(int ID_Nodo)
        {
            
            dsNodo ds = new dsNodo();

            dsNodo.NodoRow NodoAnterior;

            if (ID_Nodo == 0)
            {
                // Se  um registro novo, retorna uma linha em branco
                //                dsNodo.NodoRow NodoAnterior = ds.Nodo.NewNodoRow();
                NodoAnterior = ds.Nodo.NewNodoRow();
            }
            else
            {
                // se existe um ID, pesquisa no banco de dados
                Listar(ds, ID_Nodo);
                //                dsNodo.NodoRow NodoAnterior = ds.Nodo[0];
                NodoAnterior = ds.Nodo[0];
            }

            return NodoAnterior;
        
        }

        public void Excluir(dsNodo.NodoRow Nodo)
        {

            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@ID", Nodo.ID_Nodo));

            dsFilial ds = new dsFilial();
            base.DoSelect(ds, "p_ExcluirNodo", "ExcluirNodo");

        }



    }
}

