using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;
using SACI.Comum.DataSet; 

namespace SACI.AcessoDados
{
    public class cPerfil : cBaseAcessoDados 
    {

        public void Listar(dsPerfil ds, int id)
        {

            selectCommand = new SqlCommand();

            if (id != 0)
            {
                selectCommand.Parameters.Add(new SqlParameter("@ID_Perfil", id));
            }

            base.DoSelect(ds, "p_ListarPerfil", ds.Perfil.TableName);
        }

        public void Listar(dsPerfil ds, string clausulaWhere)
        {
            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@ClausulaWhere", clausulaWhere));
            base.DoSelect(ds, "p_ListarPerfil", ds.Perfil.TableName);
        }

        public int Salvar(dsPerfil.PerfilRow perfil)
        {

            dsPerfil.PerfilRow perfilAnterior = RetornaValorAnterior(perfil.ID_Perfil);

            selectCommand = new SqlCommand();
            //
            selectCommand.Parameters.Add(new SqlParameter("@ID", perfil.ID_Perfil));
            selectCommand.Parameters.Add(new SqlParameter("@Titulo", perfil.Titulo));
            selectCommand.Parameters.Add(new SqlParameter("@Descricao", perfil.Descricao));
            selectCommand.Parameters.Add(new SqlParameter("@Status", perfil.Status));
            //
            dsPerfil ds = new dsPerfil();
            base.DoSelect(ds, "p_SalvarPerfil", "SalvarPerfil");

            base.GeraTrilhaAuditoria(perfil.ID_Perfil , perfilAnterior, perfil);  

            //
            return int.Parse(ds.SalvarPerfil[0].Retorno.ToString());
        }

        private dsPerfil.PerfilRow RetornaValorAnterior(int ID_Perfil)
        {

            dsPerfil ds = new dsPerfil();

            dsPerfil.PerfilRow perfilAnterior;

            if (ID_Perfil == 0)
            {
                // Se  um registro novo, retorna uma linha em branco
                perfilAnterior = ds.Perfil.NewPerfilRow();
            }
            else
            {
                // se existe um ID, pesquisa no banco de dados
                Listar(ds, ID_Perfil);
                //                dsEmpresa.EmpresaRow empresaAnterior = ds.Empresa[0];
                perfilAnterior = ds.Perfil[0];
            }

            return perfilAnterior;

        }

        public void Excluir(dsPerfil.PerfilRow perfil)
        {

            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@ID", perfil.ID_Perfil));

            dsPerfil ds = new dsPerfil();
            base.DoSelect(ds, "p_ExcluirPerfil", "ExcluirPerfil");

        }


    }
}
