using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;
using SACI.Comum.DataSet;

namespace SACI.AcessoDados
{
    public class cRelatorio : cBaseAcessoDados
    {

        public void Listar(dsRelatorio ds, int id)
        {
            selectCommand = new SqlCommand();
            //
            if (id != 0)
                selectCommand.Parameters.Add(new SqlParameter("@ID_Relatorio", id));

            //
            base.DoSelect(ds, "p_ListarRelatorio", ds.Relatorio.TableName);
        }

        public void Listar(dsRelatorio ds, string clausulaWhere)
        {
            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@ClausulaWhere", clausulaWhere));
            base.DoSelect(ds, "p_ListarRelatorio", ds.Relatorio.TableName);
        }

        public int Salvar(dsRelatorio.RelatorioRow relatorio)
        {

            dsRelatorio.RelatorioRow relatorioAnterior = RetornaValorAnterior(relatorio.ID_Relatorio);

            selectCommand = new SqlCommand();
            //
            selectCommand.Parameters.Add(new SqlParameter("@ID", relatorio.ID_Relatorio));
            //selectCommand.Parameters.Add(new SqlParameter("@CNPJ", relatorio.CNPJ));
            //selectCommand.Parameters.Add(new SqlParameter("@RazaoSocial", relatorio.RazaoSocial));
            //selectCommand.Parameters.Add(new SqlParameter("@Apelido", relatorio.Apelido));
            //selectCommand.Parameters.Add(new SqlParameter("@Endereco", relatorio.Endereco));
            //selectCommand.Parameters.Add(new SqlParameter("@Bairro", relatorio.Bairro));
            //selectCommand.Parameters.Add(new SqlParameter("@Cidade", relatorio.Cidade));
            //selectCommand.Parameters.Add(new SqlParameter("@UF", relatorio.UF));
            //selectCommand.Parameters.Add(new SqlParameter("@CEP", relatorio.CEP));
            //selectCommand.Parameters.Add(new SqlParameter("@complemento", relatorio.Complemento));
            //selectCommand.Parameters.Add(new SqlParameter("@Homepage", relatorio.HomePage));
            //selectCommand.Parameters.Add(new SqlParameter("@Email", relatorio.Email));
            //selectCommand.Parameters.Add(new SqlParameter("@Ativo", relatorio.Ativo));
            //

            dsRelatorio ds = new dsRelatorio();
            base.DoSelect(ds, "p_SalvarRelatorio", "SalvarRelatorio");

            base.GeraTrilhaAuditoria(relatorio.ID_Relatorio, relatorioAnterior, relatorio);

            return int.Parse(ds.SalvarRelatorio[0].Retorno.ToString());
        }

        private dsRelatorio.RelatorioRow RetornaValorAnterior(int ID_Relatorio)
        {

            dsRelatorio ds = new dsRelatorio();

            dsRelatorio.RelatorioRow relatorioAnterior;

            if (ID_Relatorio == 0)
            {
                // Se  um registro novo, retorna uma linha em branco
                //                dsRelatorio.RelatorioRow relatorioAnterior = ds.Relatorio.NewRelatorioRow();
                relatorioAnterior = ds.Relatorio.NewRelatorioRow();
            }
            else
            {
                // se existe um ID, pesquisa no banco de dados
                Listar(ds, ID_Relatorio);
                //                dsRelatorio.RelatorioRow relatorioAnterior = ds.Relatorio[0];
                relatorioAnterior = ds.Relatorio[0];
            }

            return relatorioAnterior;

        }

        public void Excluir(dsRelatorio.RelatorioRow relatorio)
        {

            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@ID", relatorio.ID_Relatorio));

            dsFilial ds = new dsFilial();
            base.DoSelect(ds, "p_ExcluirRelatorio", "ExcluirRelatorio");

        }



    }
}

