using System;
using System.Collections.Generic;
using System.Text;

using System.Data.SqlClient;
using SACI.Comum.DataSet; 

namespace SACI.AcessoDados
{
    public class cTipoIC : cBaseAcessoDados
    {

        public void Listar(dsTipoIC ds, int id)
        {
            selectCommand = new SqlCommand();

            if (id != 0)
                selectCommand.Parameters.Add(new SqlParameter("@id", id));

            base.DoSelect(ds, "p_ListarTipoIC", ds.TipoIC.TableName);
        }

        public void Listar(dsTipoIC ds, string clausulaWhere)
        {
            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@ClausulaWhere", clausulaWhere));
            base.DoSelect(ds, "p_ListarTipoIC", ds.TipoIC.TableName);
        }

        public int Salvar(dsTipoIC.TipoICRow tipoIC)
        {

            dsTipoIC.TipoICRow tipoICAnterior = RetornaValorAnterior(tipoIC.ID_TipoIC);

            selectCommand = new SqlCommand();
            //
            selectCommand.Parameters.Add(new SqlParameter("@ID", tipoIC.ID_TipoIC));
            selectCommand.Parameters.Add(new SqlParameter("@Descricao", tipoIC.Descricao));
            selectCommand.Parameters.Add(new SqlParameter("@Observacoes", tipoIC.Observacoes));
            //
            dsTipoIC ds = new dsTipoIC();
            base.DoSelect(ds, "p_SalvarTipoIC", "SalvarTipoIC");

            base.GeraTrilhaAuditoria(tipoIC.ID_TipoIC, tipoICAnterior, tipoIC);

            //
            return int.Parse(ds.SalvarTipoIC[0].Retorno.ToString());
        }


        private dsTipoIC.TipoICRow RetornaValorAnterior(int ID_TipoIC)
        {

            dsTipoIC ds = new dsTipoIC();

            dsTipoIC.TipoICRow tipoICAnterior; 

            if (ID_TipoIC == 0)
            {
                // Se  um registro novo, retorna uma linha em branco
                tipoICAnterior = ds.TipoIC.NewTipoICRow();
            }
            else
            {
                // se existe um ID, pesquisa no banco de dados
                Listar(ds, ID_TipoIC);
                //                dsEmpresa.EmpresaRow empresaAnterior = ds.Empresa[0];
                tipoICAnterior = ds.TipoIC[0];
            }

            return tipoICAnterior;

        }

        public void Excluir(dsTipoIC.TipoICRow tipoIC)
        {

            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@ID",  tipoIC.ID_TipoIC));

            dsTipoIC ds = new dsTipoIC();
            base.DoSelect(ds, "p_ExcluirTipoIC", "ExcluirTipoIC");

        }
    
    }
}
