using System;
using SACI.Comum.DataSet;
using FluorineFx;
using System.Collections.Generic;

namespace IntegracaoFlex
{
    /// <summary>
    /// Representa uma Pessoa.
    /// </summary>
    [RemotingService]
    public class Filial
    {
        //private int _codigo;
        //private SACI.AcessoDados.cFilial oAcessoDados = new SACI.AcessoDados.cFilial();

        #region Atributos
        private int _id_Pessoa;
        /// <summary>
        /// Id da Pessoa.
        /// </summary>
        public int Id_Pessoa
        {
            get { return _id_Pessoa; }
            set { _id_Pessoa = value; }
        }
        private string _nome;
        /// <summary>
        /// Nome da Pessoa.
        /// </summary>
        public string Nome
        {
            get { return _nome; }
            set { _nome = value; }
        }
        private string _telefone;
        /// <summary>
        /// Telefone da Pessoa.
        /// </summary>
        public string Telefone
        {
            get { return _telefone; }
            set { _telefone = value; }
        }
        #endregion
        #region Construtores
        /// <summary>
        /// Construtor padro da classe.
        /// </summary>
        public Filial()
        {
        }
        /// <summary>
        /// Construtor que alimenta todos os atributos da classe.
        /// </summary>
        /// <param name="id_Pessoa">Id da Pessoa.</param>
        /// <param name="nome">Nome da Pessoa.</param>
        /// <param name="telefone">Telefone da Pessoa.</param>
        public Filial(int id_Pessoa, string nome, string telefone)
        {
            this._id_Pessoa = id_Pessoa;
            this._nome = nome;
            this._telefone = telefone;
        }
        #endregion
        #region Metodos


        public string Butao()
        {
            string _retorno = "O seu Buto foi clicado!!!!";
            return _retorno;
        }

        
        public dsFilial.FilialDataTable Listar()
        {
            dsFilial ds = new dsFilial();
            SACI.AcessoDados.cFilial oAcessoDados = new SACI.AcessoDados.cFilial();
            //oAcessoDados.Listar(ds, "Filial LIKE '%a%'");
            oAcessoDados.Listar(ds,"");
            return ds.Filial;


        }
        

        /// <summary>
        /// Insere um novo cliente no banco de dados.
        /// </summary>
        /// <returns>Cliente inserido no banco de dados.</returns>
        public string Insere(Filial _pessoa)
        {
            string _retorno = "--- Pessoa Inserida ---\n";
            _retorno += "Id_Pessoa: " + _pessoa._id_Pessoa.ToString() + "\n";
            _retorno += "Nome: " + _pessoa._nome + "\n";
            _retorno += "Telefone: " + _pessoa._telefone;
            return _retorno;
        }
        /// <summary>
        /// Seleciona uma lista de pessoas no banco de dados.
        /// </summary>
        /// <returns>Lista de pessoas cadastradas.</returns>
        public List<Filial> Lista()
        {
            List<Filial> _lista = new List<Filial>();
            //Adiciona algumas pessoas para exemplificar
            _lista.Add(new Filial(1, "Vinicius", "(16)3711-1111"));
            _lista.Add(new Filial(5, "Cristian", "(16)3722-2222"));
            _lista.Add(new Filial(9, "Juliano", "(16)3733-3333"));
            _lista.Add(new Filial(15, "Ricardo", "(16)3744-4444"));
            _lista.Add(new Filial(3, "Euripedes", "(16)3755-5555"));
            return _lista;
        }
        #endregion
    }
}
