using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using FluorineFx;
using SACI.Comum.DataSet;

namespace SACI.Negocio
{
    [RemotingService]
    public class cFilial : cBaseNegocio
    {
        private SACI.AcessoDados.cFilial cAcessoDados = new SACI.AcessoDados.cFilial();
        private dsFilial ds = new dsFilial();
        private cEmpresa cEmpresa;

        public String Listar(int id, int tipoPesquisa)
        {
            cAcessoDados.Listar(ds, id, tipoPesquisa);
            return ds.GetXml();
        }

        public String RetornarModelo()
        {
            return base.RetornarEstruturaDS(ds.Filial);
        }

        public String Salvar(String dados)
        {
            String retorno = "";

            try
            {
                dsFilial.FilialRow filialRow;
                filialRow = RetornarDataRow(ds, dados) as dsFilial.FilialRow;

                cAcessoDados.Salvar(filialRow);
            }
            catch (Exception ex)
            {
                retorno = ex.ToString();
            }

            return retorno;
        }

        public String Excluir(String dados)
        {
            String retorno = "";

            try
            {
                dsFilial.FilialRow filialRow;
                filialRow = RetornarDataRow(ds, dados) as dsFilial.FilialRow;

                cAcessoDados.Excluir(filialRow);
            }
            catch (Exception ex)
            {
                retorno = ex.ToString();
            }

            return retorno;
        }


        /*
                public void Listar(dsFilial ds, int id)
                {
                    oAcessoDados.Listar(ds, id);
                }
        
                public void Listar(dsFilial ds, string clausulaWhere)
                {
                    oAcessoDados.Listar(ds, clausulaWhere);
                }

                public int Salvar(dsFilial.FilialRow filial)
                {
                    return oAcessoDados.Salvar(filial);
                }
 
                public String ListarCombo(int id, int tipoPesquisa)
                {
                    String retorno;
                    retorno = "<combo>";

                    //char[] aSenha = new char[4];
                    //Array aRetorno;

            
                    oAcessoDados.Listar(ds, id, tipoPesquisa);
            
                    foreach (dsFilial.FilialRow filialRow in ds.Filial)
                    {
                        retorno += "<item label=\"" + filialRow.Filial + "\" data=\"" + filialRow.ID_Filial + "\" />";
                    }

                    retorno += "</combo>";

                    return retorno;
                    //return ds.GetXml();
                }
 
 
 
          */
    }
}
