using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using FluorineFx;
using SACI.Comum.DataSet;

namespace SACI.Negocio
{
    [RemotingService]
    public class cIC : cBaseNegocio
    {
        private SACI.AcessoDados.cIC cAcessoDados = new SACI.AcessoDados.cIC();
        private dsIC ds = new dsIC();
        private cDepartamento cDepartamento;
        private cTipoIC cTipoIC;
        private cFornecedor cFornecedor;
        private cTipoICAtributo cTipoICAtributo;
        private cTipoICAtributoItem cTipoICAtributoItem;
        private cUsuario cUsuario;
        private cSNMP cSNMP;

        public String Listar(int id, int tipoPesquisa)
        {
            cAcessoDados.Listar(ds, id, tipoPesquisa);
            return ds.GetXml();
        }

        public String RetornarModelo()
        {
            return base.RetornarEstruturaDS(ds.IC);
        }

        public String Salvar(String dados)
        {
            String retorno = "";

            try
            {
                dsIC.ICRow icRow;
                icRow = RetornarDataRow(ds, dados) as dsIC.ICRow;

                retorno = "ID_IC:" + cAcessoDados.Salvar(icRow).ToString();
            }
            catch (Exception ex)
            {
                retorno = ex.ToString();
            }

            return retorno;
        }

        public String Excluir(String dados)
        {
            String retorno = "";

            try
            {
                dsIC.ICRow icRow;
                icRow = RetornarDataRow(ds, dados) as dsIC.ICRow;

                cAcessoDados.Excluir(icRow);
            }
            catch (Exception ex)
            {
                retorno = ex.ToString();
            }

            return retorno;
        }

        public String ListarICAtributo(int id_IC, int id_TipoIC, int id_ICAtributo)
        {
            cAcessoDados.ListarICAtributo(ds, id_IC, id_TipoIC, id_ICAtributo);
            return ds.GetXml();
        }
        
        public String RetornarModeloICAtributo()
        {
            return base.RetornarEstruturaDS(ds.ICAtributo);
        }

        public String ListarTipoICAtributoItem(int id_TipoIC)
        {
            cAcessoDados.ListarTipoICAtributoItem(ds, id_TipoIC);
            return ds.GetXml();
        }

        public String SalvarICAtributo(String dados)
        {
            String retorno = "";

            try
            {
                dsIC.ICAtributoRow icAtributoRow;
                icAtributoRow = RetornarDataRow(ds, dados) as dsIC.ICAtributoRow;

                cAcessoDados.SalvarICAtributo(icAtributoRow);
            }
            catch (Exception ex)
            {
                retorno = ex.ToString();
            }

            return retorno;
        }


        public String ListarICAtributoHistorico(int id_ICAtributo)
        {
            cAcessoDados.ListarICAtributoHistorico(ds, id_ICAtributo);
            return ds.GetXml();
        }

    }
}
