   IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'p_ListarIC')
	BEGIN
		DROP  Procedure  p_ListarIC
	END

GO

CREATE Procedure dbo.p_ListarIC
	(
		@ID_IC int = NULL
		,@TipoPesquisa int = 0    -- (0)ICs - (1)ICPai - (2)ICs Filhos - (3)ICs Relacionados
		,@ClausulaWhere varchar(250) = NULL
	)
AS

DECLARE @Where varchar(1000)


IF(@TipoPesquisa = 0)
	BEGIN
		-- Adiciona Pesquisa do ID
		IF(@ID_IC IS NOT NULL)
			BEGIN
				SET @Where = ' I.ID_IC=' + CONVERT(VARCHAR,@ID_IC)
			END
		ELSE
			BEGIN
				-- seta como espao, porque se for null retorna null na soma do IF abaixo.
				SET @Where = ' ' 
			END
	END
ELSE IF (@TipoPesquisa = 1) -- IC Pai
	BEGIN
		SET @Where = ' I.ID_IC= (SELECT ID_ICPai FROM IC WHERE ID_IC=' + CONVERT(VARCHAR,@ID_IC) + ') '
	END
ELSE IF (@TipoPesquisa = 2) -- ICs Filhos
	BEGIN
		SET @Where = ' I.ID_ICPai = ' + CONVERT(VARCHAR,@ID_IC) 
	END
ELSE IF (@TipoPesquisa = 3) -- ICs Filhos
	BEGIN
		SET @Where = ' I.ID_IC IS NOT NULL'  
	END


-- Adiciona clausula Where
IF (@ClausulaWhere IS NOT NULL)
	BEGIN

		IF(@Where <> ' ')
			BEGIN
				SET @Where = @Where + ' AND'
			END
		SET @Where = @Where + ' ' + @ClausulaWhere
	END

	DECLARE @sSql varchar(7000)
	SET @sSql = 'SELECT I.ID_IC as ID_IC, I.Descricao as Descricao, I.IP as IP, I.Status as Status, I.Monitorar as Monitorar, I.ID_TipoIC AS ID_TipoIC, I.ID_Departamento AS ID_Departamento '
	SET @sSql = @sSql + ',T.Descricao AS TipoIC_Descricao, Departamento, I.ID_ICPai as ID_ICPai, (TIP.Descricao + '': '' + IP.Descricao) as ICPaiDescricao '  
	SET @sSql = @sSql + 'FROM IC I '
	SET @sSql = @sSql + 'LEFT JOIN TipoIC T ON T.ID_TipoIC = I.ID_TipoIC '
	SET @sSql = @sSql + 'LEFT JOIN Departamento D ON D.ID_Departamento = I.ID_Departamento '
	SET @sSql = @sSql + 'LEFT JOIN IC IP ON IP.ID_IC = I.ID_ICPai '
	SET @sSql = @sSql + 'LEFT JOIN TipoIC TIP ON TIP.ID_TipoIC = IP.ID_TipoIC '
	
	IF (@Where <> ' ') 
		BEGIN
			SET @sSQL = @sSQL + ' WHERE' + @Where
		END

execute(@sSql)