
  IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'p_ListarLog')
	BEGIN
		DROP  Procedure  p_ListarLog
	END

GO

CREATE Procedure dbo.p_ListarLog
	(
		@ID int = NULL 
		,@ClausulaWhere varchar(1000) = NULL
	)
AS

DECLARE @Where varchar(1000)

-- Adiciona Pesquisa do ID
IF(@ID IS NOT NULL)
	BEGIN
		SET @Where = ' ID_TrilhaAuditoria=' + CONVERT(VARCHAR,@ID)
	END
ELSE
	BEGIN
		-- seta como espao, porque se for null retorna null na soma do IF abaixo.
		SET @Where = ' ' 
	END


-- Adiciona clausula Where
IF (@ClausulaWhere IS NOT NULL)
	BEGIN

		IF(@Where <> ' ')
			BEGIN
				SET @Where = @Where + ' AND'
			END
		SET @Where = @Where + ' ' + @ClausulaWhere
	END

DECLARE @sSql varchar(7000)
SET @sSql = '
SELECT 
	T.ID_TrilhaAuditoria,
	T.ID_Controle,
	C.Descricao as Controle,
	T.ID_Campo,
	CP.Descricao as Campo,
	T.ID_Usuario,
	U.Login as Usuario,
	T.IDalterado,
	T.DataHoraAlteracao,
	T.Valoranterior,
	T.ValorNovo,
	T.TipoLog,
	CASE WHEN T.TipoLog = 1 Then ''Incluso'' ELSE ''Alterao'' END as TextoTipoLog
FROM 
	TrilhaAuditoria T
	LEFT JOIN Controle C ON C.ID_Controle = T.ID_Controle
	LEFT JOIN Campo CP ON CP.ID_Campo = T.ID_Campo
	LEFT JOIN Usuario U ON U.ID_Usuario = T.ID_Usuario 
'
	IF (@Where <> ' ') 
		BEGIN
			SET @sSQL = @sSQL + ' WHERE' + @Where
		END

execute(@sSql)